/**
 * Date:            Time:       User:               Description:
 * 17.03.2006       23:36       Smart Max           creation of the file PathBuilder.java
 *
 */
package org.max.xml.index;

import org.max.trie.ISymbol;
import static org.w3c.dom.Node.ELEMENT_NODE;
import static org.w3c.dom.Node.TEXT_NODE;
import static org.w3c.dom.Node.ATTRIBUTE_NODE;

import java.util.List;
import java.util.ArrayList;

/**
 * PathBuilder
 */
abstract class PathBuilder {
    public static List<ISymbol> makeList(String path) {
        List<ISymbol> result = new ArrayList<ISymbol>();

        int type = ELEMENT_NODE;
        int i = 0;
        while (i < path.length()) {
            char ch = path.charAt(i);

            if (ch == '>') {
                type = TEXT_NODE;
                i++;
            } else {
                if (i + 1 < path.length() && path.charAt(i + 1) == '\'') {
                    result.add(new Symbol(ch, ATTRIBUTE_NODE));
                    i += 2;
                } else {
                    result.add(new Symbol(ch, type));
                    i++;
                }
            }
        }

        return result;
    }
}
